<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <title>AdminLTE 3 | Blank Page</title>

    <!-- Google Font: Source Sans Pro -->
    <link
      rel="stylesheet"
      href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback"
    />
    <!-- Font Awesome -->
    <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css" />
    <!-- Theme style -->
    <link rel="stylesheet" href="dist/css/adminlte.min.css" />
  </head>
  <body class="hold-transition sidebar-mini">
    <!-- Site wrapper -->
    <div class="wrapper">
      <!-- Navbar -->
      <nav class="main-header navbar navbar-expand navbar-white navbar-light">
        <!-- Left navbar links -->
        <ul class="navbar-nav">
          <li class="nav-item">
            <a class="nav-link" data-widget="pushmenu" href="#" role="button"
              ><i class="fas fa-bars"></i
            ></a>
          </li>
          <li class="nav-item d-none d-sm-inline-block">
            <a href="index3.html" class="nav-link">Home</a>
          </li>
          <li class="nav-item d-none d-sm-inline-block">
            <a href="#" class="nav-link">Contact</a>
          </li>
        </ul>
      </nav>
      <!-- /.navbar -->

      <!-- Main Sidebar Container -->
      <aside class="main-sidebar sidebar-dark-primary elevation-4">
        <!-- Brand Logo -->
        <a href="index3.html" class="brand-link">
          <img
            src="dist/img/AdminLTELogo.png"
            alt="AdminLTE Logo"
            class="brand-image img-circle elevation-3"
            style="opacity: 0.8"
          />
          <span class="brand-text font-weight-light">Devcamp 120</span>
        </a>

        <!-- Sidebar -->
        <div class="sidebar">
          <!-- Sidebar user (optional) -->
          <div class="user-panel mt-3 pb-3 mb-3 d-flex">
            <div class="image">
              <img
                src="dist/img/user2-160x160.jpg"
                class="img-circle elevation-2"
                alt="User Image"
              />
            </div>
            <div class="info">
              <a href="#" class="d-block">Đinh Nhật Toàn</a>
            </div>
          </div>

          <!-- SidebarSearch Form -->
          <div class="form-inline">
            <div class="input-group" data-widget="sidebar-search">
              <input
                class="form-control form-control-sidebar"
                type="search"
                placeholder="Search"
                aria-label="Search"
              />
              <div class="input-group-append">
                <button class="btn btn-sidebar">
                  <i class="fas fa-search fa-fw"></i>
                </button>
              </div>
            </div>
          </div>

          <!-- Sidebar Menu -->
          <nav class="mt-2">
            <ul
              class="nav nav-pills nav-sidebar flex-column"
              data-widget="treeview"
              role="menu"
              data-accordion="false"
            >
              <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
              <li class="nav-item menu-open">
                <a href="#" class="nav-link active">
                  <i class="nav-icon fas fa-tachometer-alt"></i>
                  <p>
                    Dashboard
                    <i class="right fas fa-angle-left"></i>
                  </p>
                </a>
                
                <li class="nav-item">
                  <a href="voucher.html" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>voucher</p>
                  </a>
                </li>
                <li class="nav-item">
                  <a href="menu.html" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Menu</p>
                  </a>
                </li>
                <li class="nav-item">
                  <a href="drink.html" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Drink</p>
                  </a>
                </li>
                <li class="nav-item">
                  <a href="country.html" class="nav-link active">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Country</p>
                  </a>
                </li>
                <li class="nav-item">
                  <a href="region.html" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Region</p>
                  </a>
                </li>
                <li class="nav-item">
                  <a href="district.html" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>District</p>
                  </a>
                </li>
                <li class="nav-item">
                  <a href="user.html" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>User</p>
                  </a>
                </li>
                <li class="nav-item">
                  <a href="order.html" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Order</p>
                  </a>
                </li>
                  
                </ul>
              </li>
            </ul>
          </nav>
          <!-- /.sidebar-menu -->
        </div>
        <!-- /.sidebar -->
      </aside>

      <!-- Content Wrapper. Contains page content -->
      <div class="content-wrapper">
        <!-- Content Header (Page header) -->
        <section class="content-header">
          <div class="container-fluid">
            <div class="row mb-2">
              <div class="col-sm-6">
                <h1>Country</h1>
              </div>
              <div class="col-sm-6">
                <ol class="breadcrumb float-sm-right">
                  <li class="breadcrumb-item"><a href="#">Home</a></li>
                  <li class="breadcrumb-item active">User</li>
                </ol>
              </div>
            </div>
          </div>
          <!-- /.container-fluid -->
        </section>

        <!-- Main content -->
        <section class="content text-center">
          <div class="container text-center">
            <h2 class="text-center">Country</h2>

            <form id="inputform01" class="jumbotron container">
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="country">Tên Nước</label>
                </div>
                <div class="col-sm-6">
                  <input type="text" id="country-input" class="form-control" placeholder="Tên Nước">
                </div>
                
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="code">Mã</label>
                </div>
                <div class="col-sm-6">
                  <input type="text" id="code-input" class="form-control" placeholder="Mã">
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-0">
                  <button id="create-data" class="btn btn-success">Create</button>
                  <button id="update-data" class="btn btn-info">Update</button>
                  <button id="delete-data" class="btn btn-danger">Delete</button>
                  <button id="cancel-data" class="btn btn-warning">Cancel</button>
                </div>
              </div>
              <table class="table table-bordered table-striped table-hover" id="user-table">
                <thead>
                  <tr>
                    <th>STT</th>
                    <th>Mã nước</th>
                    <th>Tên nước</th>
                  </tr>
              </table>
            </form>
          </div>
        </section>
        <!-- /.content -->
      </div>
      <!-- /.content-wrapper -->

      <footer class="main-footer">
        <div class="float-right d-none d-sm-block"><b>Version</b> 1.0.0</div>
        <strong
          >Copyright &copy; 2023
          <a href="https://adminlte.io">Devcamp 120</a>.</strong
        >
        All rights reserved.
      </footer>
      <!-- /.control-sidebar -->
    </div>
    <!-- ./wrapper -->

    <!-- jQuery -->
    <script src="plugins/jquery/jquery.min.js"></script>
    <!-- Bootstrap 4 -->
    <script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
    <!-- AdminLTE App -->
    <script src="dist/js/adminlte.min.js"></script>

    <!-- Import them style bootstrap cho datatable -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>

    <script>
      "use strict";
      
	    const gBASE_URL ="http://localhost:8080/country";
      var gObjectCountry = [];
	    var vId = 0;

      var table = $("#user-table").DataTable({
        "columns": [
          {"data":"id"},
          {"data":"countryCode"},
          {"data":"countryName"},
        ]
      });

      $(document).ready(function(){
        getApiCountryAll();

        $('#user-table').on('click', 'tr', function(){
            vId = $(this).find('td:first').text();
            loadCountryDataById(vId);
        });
        
        $('#create-data').on('click', function(){
				var vObj ={
          countryCode:"",
					countryName:""
				}
				getDataForm(vObj);
				var vIsValidate = validateData(vObj);
				if(vIsValidate){
					getCreateDataApi(vObj);
					resetForm();
				}
       });

       $('#update-data').on('click', function(){
            var vObj ={
              countryCode:"",
					    countryName:""
            }
            getDataForm(vObj);
            getUpdateDataApi(vId, vObj);
            resetForm();
        });

        $('#delete-data').on('click', function(){
          deleteCountryId(vId);
          resetForm();
        });
      });

      function loadCountryDataById(id) {
        fetch(`http://localhost:8080/country/detail/${id}`)
        .then(response => response.json())
        .then(data => {
          // Hiển thị thông tin Drink lên form
          $('#country-input').val(data.countryName);
          $('#code-input').val(data.countryCode);
        })
        .catch(error => console.error(error.responseText));
      }

      //Get data province
      function getApiCountryAll(){
        $.ajax({
        url: gBASE_URL + "/all",
        method: "GET",
        success: function (pObjRes) {
          console.log(pObjRes);
          gObjectCountry = pObjRes;
          DisplayCountryToTable(pObjRes);
        },
        error: function (e) {
          console.log(e.responseText);
        },
      });
      }

      function DisplayCountryToTable(paramData) {
        "use strict";
        $("#user-table").DataTable().clear(); // xóa dữ liệu
        $("#user-table").DataTable().rows.add(paramData); //thêm các dòng dữ liệu vào datatable
        $("#user-table").DataTable().draw(); //vẽ lại bảng
      }

      function getDataForm(paramObj){
        paramObj.countryName = $('#country-input').val();
        paramObj.countryCode = $('#code-input').val();
      }

      function getCreateDataApi(pObject) {
        $.ajax({
          url: gBASE_URL + "/create",
          type: "POST",
          contentType: "application/json;charset=UTF-8",
          data: JSON.stringify(pObject),
          success: function(res){
            getApiCountryAll();
          },
          error: function(err){
            console.log(err.responseText);
          }
        });
      }

      function resetForm(){
        $('#country-input').val("");
        $('#code-input').val("");
      }

      function getUpdateDataApi(pId, pObject) {
        $.ajax({
          url: gBASE_URL+ "/update/" + pId,
          type: "PUT",
          contentType: "application/json;charset=UTF-8",
          data: JSON.stringify(pObject),
          success: function(res){
            getApiCountryAll();
          },
          error: function(err){
            console.log(err.responseText);
          }
        });
      }

      function validateData(paramObj){
        if(paramObj.countryName == 0){
          alert("Bạn chưa điền tên nước!");
          return false;
        }
        if(paramObj.countryCode == 0){
          alert("Bạn chưa điền mã nước!");
          return false;
        }
        return true;
      }

      function deleteCountryId(pId) {
        $.ajax({
          url: gBASE_URL + "/delete/" + pId,
          type: "DELETE",
          async: false,
          success: function (paramOrderRes) {
            getApiCountryAll();
          },
          error: function (paramErr) {
            console.log(paramErr.status);
          },
        });
      }
    </script>
  </body>
</html>
